# -*- coding: utf-8 -*-

# ------------------------------------------------------------
# directly start the browsing
# 
# Autor: Oliver Maurhart, <oliver.maurhart@ait.ac.at>
#        Mihai Bartha, <mihai.bartha@ait.ac.at>       
#
# Copyright 2013-2014 X-Net and AIT Austrian Institute of Technology
# 
# 
#     X-Net Services GmbH
#     Elisabethstrasse 1
#     4020 Linz
#     AUSTRIA
#     https://www.x-net.at
# 
#     AIT Austrian Institute of Technology
#     Donau City Strasse 1
#     1220 Wien
#     AUSTRIA
#     http://www.ait.ac.at
# 
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ------------------------------------------------------------


# ------------------------------------------------------------
# imports

import sys
import urllib
import urllib2

from PyQt4 import QtCore
from PyQt4 import QtGui

# local
import __init__ as opensecurity
import proxy_getter

if sys.platform == 'win32' or sys.platform == 'cygwin':
    from cygwin import Cygwin


# ------------------------------------------------------------
# code


# start
if __name__ == "__main__":

    if not (sys.platform == 'win32' or sys.platform == 'cygwin'):
        QtGui.QMessageBox.critical(None, 'OpenSecurity Error', 'This action is not supported on this platform.\nSorry.')
        sys.exit(1)
   
    try:
    
        # get a proper browsing VM
        Cygwin.start_X11()
        
        proxy_support = urllib2.ProxyHandler({})
        opener = urllib2.build_opener(proxy_support)
        urllib2.install_opener(opener)

        req_data = ""
        proxy = proxy_getter.getProxySettings()
        if proxy:
            req_data = '?' + urllib.urlencode(proxy) 
        req = 'http://127.0.0.1:8080/browsing'+ req_data
        browsing_vm = urllib2.urlopen(req).readline()
        print('Called '+ req + ' got: ' + str(browsing_vm))
        
    except:
        
        QtGui.QApplication.instance().processEvents()
        QtGui.QMessageBox.critical(None, 'Failed to invoke Safe Internet Browsing', 'OpenSecurity Error')

